Bug 845505 - gcc defaulting to ccache causes unnecessary problems
gcc defaulting to ccache causes unnecessary problems
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: ccache (Show other bugs)
17
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Ville Skyttä
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-03 05:18 EDT by bob mckay
Modified: 2013-08-01 08:59 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-01 08:58:56 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description bob mckay 2012-08-03 05:18:22 EDT
gcc has been defaulted to use ccache, apparently from F17 onward. This was presumably on the basis that it was a transparent change. However it isn't transparent, at least in my case:

1. We do a lot of run-time compilation and linking (genetic programming systems, if you're interested why). We first discovered there was a problem when we started filling up filesystems with useless ccaches.

2. On our cluster, home directories are cross-mounted. So ccaches being written by default to /home unnecessarily chew up network bandwidth.

Both are fixable. But they shouldn't need fixing. ccache is a great idea, by all means encourage its use. But not to the extent of creating non-transparent default changes. This is the kind of change that fedora users expect to have to swallow. But it will cause a lot of heartburn if it goes into RHEL (where a lot of installations will face large challenges in chasing down these issues).
Comment 1 Jakub Jelinek 2012-08-09 19:02:34 EDT
gcc doesn't default to ccache in any way, only if you install ccache, it will add itself to PATH earlier.  So, don't install ccache if you don't want to use it.
Comment 2 bob mckay 2012-08-09 22:18:43 EDT
Thanks for the explanation, Jakub. 

Unfortunately I'm not sure, though, that I or others can use it. It's pretty clear that the problems I'm having will bite others too (even if they don't realise yet - and perhaps won't unless/until it goes into RHEL). The basic issue is that there has been a regression: things which used to work now don't (and rather worse than don't work, users can inadvertently cause system hangs when /home fills up with unexpected cache files).

I'm not installing ccache explicitly. It's coming as part of development-tools (perhaps it wasn't up to Fedora 16). Of course, I do need development-tools on a research cluster (and others with clusters or large-scale workstation deployments will too). Anyone like me doing automated installs can't simply remove ccache after the install, we need it not to be automatically activated in the first place. 

But equally important "don't install ccache if you don't want to use it." is really only suitable advice for single-user machines. It's not a suitable distribution policy. The need for ccache may vary from user to user, or from project to project.

Up to Fedora 16, ccache wasn't causing problems (perhaps because it wasn't getting installed). Now in Fedora 17 it does. This is a regression. It results from the interaction of two defaults: that ccache is installed as part of development-tools, and that it installs itself in the path ahead of gcc. Personally, I think the latter is the mistake: since ccache isn't transparent, it should require user action to activate it. This is a decision that only the individual user has the information to make: it is not, and should not be, a system-level decision.
Comment 3 bob mckay 2012-08-09 22:41:35 EDT
For anyone else hitting this problem, the kickstart structure that may be helpful is:
%packages
...
@development-tools
...
-ccache
...
%end
(not yet verified, but I assume it will work).
Comment 4 Fedora End Of Life 2013-07-04 00:12:23 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Fedora End Of Life 2013-08-01 08:59:00 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.